////////////////////////////////////////////////////////////////////////////////
//	Filename :		GDIPong.cpp
//	Description :	Main file for GDIPong.
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//	Included headers
////////////////////////////////////////////////////////////////////////////////
#include	"GDIPong.h"


////////////////////////////////////////////////////////////////////////////////
//	Definitions
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//	Global variables
////////////////////////////////////////////////////////////////////////////////
char	szClassName[]	=	"GDIPong";
char	szWinName[]		=	"GDIPong - version 1.0";

HDC		hMainDC;
HDC		hAlienDC;
HDC		hTruck1DC;
HDC		hTruck2DC;

int		Player1Score;
int		Player1Position;

int		Player2Score;
int		Player2Position;

float	BallDirectionX;
float	BallDirectionY;
float	BallPositionX;
float	BallPositionY;
bool	BallRolling;
	

////////////////////////////////////////////////////////////////////////////////
//	Structures
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//	Classes
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//	Function prototypes
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//	Function name :	WinMain ()
//	Description :	Start up of the game.
////////////////////////////////////////////////////////////////////////////////
int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR Cmd, int Show)

{

	MSG				msg;
	HWND			hWnd;
	WNDCLASSEX		wcl;

	bool			Running;

	ZeroMemory (&wcl, sizeof (WNDCLASSEX));
	wcl.cbSize			=	sizeof (WNDCLASSEX);
	wcl.hInstance		=	hInst;
	wcl.lpszClassName	=	szClassName;
	wcl.lpfnWndProc		=	 WndProc;
	wcl.style			=	0;

	wcl.lpszMenuName	=	NULL;
	wcl.cbClsExtra		=	NULL;
	wcl.cbWndExtra		=	NULL;

	wcl.hIcon	=	LoadIcon (NULL, IDI_APPLICATION);
	wcl.hIconSm	=	LoadIcon (NULL, IDI_APPLICATION);
	wcl.hCursor	=	LoadCursor (NULL, IDC_ARROW);
	wcl.hbrBackground	=	(HBRUSH) GetStockObject(BLACK_BRUSH);

	if (!RegisterClassEx(&wcl)) 
		
	{
	
		MessageBox (NULL, "Couldn't register Window! Aborting...", "GDIPong", MB_OK);	
		
		return (-1);
		
	}

	hWnd = CreateWindow (szClassName, szWinName, WS_POPUP,0 , 0, 640, 480, 
						 HWND_DESKTOP, NULL, hInst, NULL);

	ShowWindow(hWnd, Show);

	LoadBitmaps ();

	BallPositionX = 50;
	BallPositionY = 240;

	srand (GetTickCount ());

	BallDirectionX = (rand () % 3) + 2;
	BallDirectionY = 5 - BallDirectionX;
	
	Player1Position = 200;
	Player2Position = 200;

	if (rand () % 2)

	{

		BallDirectionY *= -1;

	}

	Running = true;

	CScreen		Screen(hWnd);
	Screen.SetDisplayMode (640, 480, 16, SURFACE_PRIMARY_SECONDARY);


	while (Running)

	{

        if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))

        {
        
			if (msg.message == WM_QUIT)
            
			{
			
				Running = false;
			
			}
			
			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

		else 
		
		{

			Process ();
			CheckCol ();
			Screen.CSecondary.ClearSurface(0,0,0);
			DrawScreen (&Screen);
			Screen.Flip ();

		}

	}

	return 0;
}


////////////////////////////////////////////////////////////////////////////////
//	Function name :	WndProc ()
//	Description :	Handles messages.
////////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc (HWND hWnd,UINT msg , WPARAM wParam, LPARAM lParam)

{

	switch (msg)
	
	{

	case	WM_KEYDOWN:

		switch ((int) wParam)

		{


		case	'A':

			Player1Position -= SPEED;

			if (Player1Position <= 0)

			{

				Player1Position = 0;

			}

			else if (Player1Position >= 379)

			{

				Player1Position = 379;

			}

			return 0;

		case	'Z':

			Player1Position += SPEED;
			
			if (Player1Position <= 0)

			{

				Player1Position = 0;

			}

			else if (Player1Position >= 379)

			{

				Player1Position = 379;

			}
			
			return 0;

		case	VK_UP:

			Player2Position -= SPEED;
			
			if (Player2Position <= 0)

			{

				Player2Position = 0;

			}

			else if (Player2Position >= 379)

			{

				Player2Position = 379;

			}

			return 0;

		case	VK_DOWN:

			Player2Position += SPEED;
			
			if (Player2Position <= 0)

			{

				Player2Position = 0;

			}

			else if (Player2Position >= 379)

			{

				Player2Position = 379;

			}

			return 0;

		case	VK_SPACE:

			BallRolling = true;

			return 0;

		}

		break;

	case	WM_COMMAND:


		break;
	
	case	WM_DESTROY:

		PostQuitMessage(0);
		break;

	default:

		return DefWindowProc (hWnd, msg, wParam, lParam);
		break;

	}
	
	return 0;

}


////////////////////////////////////////////////////////////////////////////////
//	Function name :	DrawScreen ()
//	Description :	Draws the 'paddles' and the 'ball'.
////////////////////////////////////////////////////////////////////////////////
bool	DrawScreen (CScreen *Screen)

{

	char	Message [256];

	Screen->CSecondary.lpSurface->GetDC (&hMainDC);

	sprintf (Message, "%d - %d", Player1Score, Player2Score);
	TextOut (hMainDC, 300,210, Message, strlen (Message));

	BitBlt (hMainDC, PLAYER1X, Player1Position, 32, 76, hTruck1DC, 0,0, SRCCOPY); 
	BitBlt (hMainDC, PLAYER2X, Player2Position, 32, 76, hTruck2DC, 0,0, SRCCOPY); 
	BitBlt (hMainDC, (int)BallPositionX, (int)BallPositionY, 32, 20, hAlienDC, 0,0, SRCCOPY); 

	Screen->CSecondary.lpSurface->ReleaseDC (hMainDC);

	return false;

}


////////////////////////////////////////////////////////////////////////////////
//	Function name :	LoadBitmaps ()
//	Description :	Loads the Bitmaps.
////////////////////////////////////////////////////////////////////////////////
bool	LoadBitmaps ()

{

	HBITMAP hTruck1;
	HBITMAP hTruck2;
	HBITMAP hAlien;

	hTruck1DC = CreateCompatibleDC (hMainDC);

	hTruck1 = CreateCompatibleBitmap(hTruck1DC, 0, 0);
 
	hTruck1 = (HBITMAP) LoadImage (NULL, "Truck1.bmp", IMAGE_BITMAP, NULL, 
								NULL, LR_LOADFROMFILE | LR_CREATEDIBSECTION);

	SelectObject (hTruck1DC, hTruck1);

	hTruck2DC = CreateCompatibleDC (hMainDC);

	hTruck2 = CreateCompatibleBitmap(hTruck2DC, 0, 0);
 
	hTruck2 = (HBITMAP) LoadImage (NULL, "Truck2.bmp", IMAGE_BITMAP, NULL, 
								NULL, LR_LOADFROMFILE | LR_CREATEDIBSECTION);

	SelectObject (hTruck2DC, hTruck2);

	hAlienDC = CreateCompatibleDC (hMainDC);

	hAlien = CreateCompatibleBitmap(hAlienDC, 0, 0);
 
	hAlien = (HBITMAP) LoadImage (NULL, "Alien.bmp", IMAGE_BITMAP, NULL, 
								NULL, LR_LOADFROMFILE | LR_CREATEDIBSECTION);

	SelectObject (hAlienDC, hAlien);

	return false;

}


////////////////////////////////////////////////////////////////////////////////
//	Function name :	Process ()
//	Description :	Processes the game logic.
////////////////////////////////////////////////////////////////////////////////
bool	Process ()

{

	if (BallRolling)

	{
	
		BallPositionX += BallDirectionX;
		BallPositionY += BallDirectionY;

	}

	return false;

}


////////////////////////////////////////////////////////////////////////////////
//	Function name :	CheckCol ()
//	Description :	Checks collision detection with walls and 'paddles'.
////////////////////////////////////////////////////////////////////////////////
BYTE	CheckCol ()

{

	if (BallPositionY <= 0)

	{

		BallDirectionY *= -1;

	}

	else if (BallPositionY >= 434)

	{

		BallDirectionY *= -1;

	}

	else if (BallPositionX <= 0)

	{

		srand (GetTickCount ());

		BallDirectionX = (rand () % 3) + 2;
		BallDirectionY = 5 - BallDirectionX;

		if (rand () % 2)

		{

			BallDirectionY *= -1;

		}

		BallRolling = false;

		BallPositionX = 50;
		BallPositionY = 240;

		Player2Score ++;
	
	}

	else if (BallPositionX >= 602)

	{

		srand (GetTickCount ());

		BallDirectionX = (rand () % 3) + 2;
		BallDirectionY = 5 - BallDirectionX;

		if (rand () % 2)

		{

			BallDirectionY *= -1;

		}


		BallDirectionX *= -1;
		
		BallPositionX = 550;
		BallPositionY = 240;

		BallRolling = false;		

		Player1Score ++;

	}

	else if ((BallPositionX >560) && (BallPositionX < 566) && (BallPositionY > Player2Position) && (BallPositionY < Player2Position + 72))

	{

		BallDirectionX *=-1;
		
	}

	else if ((BallPositionX > 37) && (BallPositionX < 43) && (BallPositionY > Player1Position) && (BallPositionY < Player1Position + 72))

	{

		BallDirectionX *=-1;
		
	}

	return 1;

}