//////////////////////////////////////////////////////////////////////
//
//
//		File :					"PhoenixInput.h"
//
//
//		Original author :		Bruno Sousa
//
//
//		Creation date :			05 - 02 - 2000
//
//
//		Last modified by :		Bruno Sousa
//
//
//		Last modified :			05 - 02 - 2000
//
//
//		Purpose :				DirectDraw object implementation.
//								All primitive graphics functions are
//								declared in this file. 
//								Header file for PhoenixGraphics.h
//
//
//		Observations :			None.
//
//
//////////////////////////////////////////////////////////////////////
#ifndef		PHOENIXINPUT_H
#define		PHOENIXINPUT_H


//////////////////////////////////////////////////////////////////////
//
//
//		Included headers
//
//
//////////////////////////////////////////////////////////////////////
/*  DirectDraw 7 header file  */
#include	<dinput.h>


//////////////////////////////////////////////////////////////////////
//
//
//		Definitions
//
//
//////////////////////////////////////////////////////////////////////
#define		PMOUSE							0 << 0
#define		PKEYBOARD						1 << 0

#define		ERRINPUT_NOQUIT					0 << 0
#define		ERRINPUT_QUIT					1 << 0
#define		ERRINPUT_DIALOG					1 << 1
#define		ERRINPUT_FILE					1 << 2

#define		ERRINPUT_DI_CREATE				1 << 0
#define		ERRINPUT_DI_RELEASE				2 << 0
#define		ERRINPUT_KCREATE_DI_DEVICE		3 << 0
#define		ERRINPUT_KSET_DI_COOPERATIVE	4 << 0
#define		ERRINPUT_KSET_DATA_FORMAT		5 << 0
#define		ERRINPUT_MCREATE_DI_DEVICE		6 << 0
#define		ERRINPUT_MSET_DI_COOPERATIVE	7 << 0
#define		ERRINPUT_MSET_DATA_FORMAT		8 << 0


//////////////////////////////////////////////////////////////////////
//
//
//		Classes
//
//
//////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////
//
//
//		Name :					CInput
//
//
//		Original author :		Bruno Sousa
//
//
//		Creation date :			02 - 02 - 2000
//
//
//		Last modified by :		Bruno Sousa
//
//
//		Last modified :			04 - 02 - 2000
//
//
//		Purpose :				Input object. All the user input will
//								be done using the CInput class.
//
//
//		Observations :			Not finished.
//
//
//////////////////////////////////////////////////////////////////////
class	CInput

{

public:

	CInput(HINSTANCE hInstance);
	~CInput();

};


//////////////////////////////////////////////////////////////////////
//
//
//		Name :					CDevice
//
//
//		Original author :		Bruno Sousa
//
//
//		Creation date :			02 - 02 - 2000
//
//
//		Last modified by :		Bruno Sousa
//
//
//		Last modified :			04 - 02 - 2000
//
//
//		Purpose :				Device object, type of input and 
//								input processing.
//
//
//		Observations :			Not finished.
//
//
//////////////////////////////////////////////////////////////////////
class	CDevice

{

public:

	LPDIRECTINPUTDEVICE			lpDevice;
	LPDIRECTINPUTDEVICE2		lpDevice2;

	BYTE						byType;

	CDevice(HWND hWnd, BYTE byType);
	~CDevice();

};


#endif






